#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "../libweb/webutil.h"
#include "food.h"

/*----------------------------------------------------------------------------*/

int main( int argc, char* argv[] )
{
   entry entries[MAX_ENTRIES];
   register int x, m = 0;
   int cl;
   int got_restaurant=0, got_addr=0, got_tel=0, got_type=0;
   FILE *fp;

   printf( "Content-type: text/html%c%c", 10, 10 );

   if( strcmp( getenv( "REQUEST_METHOD" ), "POST" ) )
   {
      printf( "This script should be referenced with a METHOD of POST.\n" );
      printf( "If you don't understand this, see this ");
      printf( "<A HREF=\"http://www.ncsa.uiuc.edu/SDG/Software/Mosaic/Docs/fill-out-forms/overview.html\">forms overview</A>.%c", 10 );
      exit( 1 );
   }
   if( strcmp( getenv("CONTENT_TYPE"), "application/x-www-form-urlencoded") )
   {
      printf( "This script can only be used to decode form results.\n" );
      exit( 1 );
   }
   cl = atoi( getenv( "CONTENT_LENGTH" ) );

   for( x = 0; cl && ( !feof( stdin ) ); x++ )
   {
      m = x;
      entries[x].val = fmakeword( stdin, '&', &cl );
      plustospace( entries[x].val);
      unescape_url( entries[x].val );
      entries[x].name = makeword( entries[x].val, '=' );
   }

   printf(
   "<TITLE>Toronto's WWW Restaurant Listings -- Add restaurant</TITLE>%c",
   10 );

   for( x = 0; x <= m; x++ )
   {
      if( strcmp( entries[x].name, "restaurant" ) == 0 )
      {
         if( entries[x].val != 0 && strcmp( entries[x].val, "" ) != 0 )
            got_restaurant = 1;
         else
            printf( "You didn't fill in field 'Restaurant name'.%c", 10 );
      }
      else if( strcmp( entries[x].name, "address" ) == 0 )
      {
         if( entries[x].val != 0 && strcmp( entries[x].val, "" ) != 0 )
            got_addr = 1;
         else
            printf( "You didn't fill in field 'Street'.%c", 10 );
      }
      else if( strcmp( entries[x].name, "telephone" ) == 0 )
      {
         if( entries[x].val != 0 && strcmp( entries[x].val, "" ) != 0 )
            got_tel = 1;
         else
            printf( "You didn't fill in field 'Telephone'.%c", 10 );
      }
      else if( strcmp( entries[x].name, "type" ) == 0 )
      {
         if( entries[x].val != 0 && strcmp( entries[x].val, "" ) != 0 )
            got_type = 1;
         else
            printf( "You didn't fill in field 'Type'.%c", 10 );
      }
   }

   if( got_restaurant && got_addr && got_tel && got_type )
   {
      fp = popen( "mail -s 'Add restaurant' noik@db.toronto.edu", "w" );
         
      for( x = 0; x <= m; x++ )
         fprintf( fp, "%s: %s\n", entries[x].name, entries[x].val );
      fclose( fp );

      printf( "<P>Thank you for helping us to expand our database! " );
      printf(
      "We'll verify your submission and add it to the list shortly.<BR>" );
   }
   else
   {
      printf( "Please go back to the previous page and try again.<BR>%c", 10 );
   }

   return 0;
}

/*----------------------------------------------------------------------------*/
